CS_DirectSeedingAddon = {};
local modItem = ModsUtil.findModItemByModName(g_currentModName);

function CS_DirectSeedingAddon:loadMap(name)
	self.version = 'Direct Seeding Addon v'..((modItem and modItem.version) and modItem.version or "?.?.?").." | ";

	self.choppedStrawFound = false;
	self.notFoundInteration = 0;
	self.notFoundFinal = false;

	if g_modIsLoaded["FS17_choppedStraw"] then
		self.choppedStrawFound = true;
		self:overwriteFunctions()

		self:CS_LogInfo("ChoppedStraw mod found, addon loaded")
		-- print("ChoppedStraw_DirectSeedingAddon: ChoppedStraw mod found, addon loaded.")
	end
end;

function CS_DirectSeedingAddon:update(dt)
	if not self.choppedStrawFound and self.notFoundInteration < 500 then
		if g_modIsLoaded["FS17_choppedStraw"] then
			self.choppedStrawFound = true;
			self:overwriteFunctions()

			self:CS_LogInfo("ChoppedStraw mod found, addon loaded")
			-- print("ChoppedStraw_DirectSeedingAddon: ChoppedStraw mod found, addon loaded.")
		end

		self.notFoundInteration = self.notFoundInteration + 1;
	end

	if self.notFoundInteration >= 500 and not self.notFoundFinal then
		print("ChoppedStraw_DirectSeedingAddon: ATTENTION! ChoppedStraw mod not found, addon disabled!")
		self.notFoundFinal = true;
	end
end

function CS_DirectSeedingAddon:overwriteFunctions()
	Utils.updateDirectSowingArea = Utils.overwrittenFunction(Utils.updateDirectSowingArea, CS_DirectSeedingAddon.updateDirectSowingArea);
end	

function CS_DirectSeedingAddon:updateDirectSowingArea(superFunc, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, angle, plantValue)
	_G["FS17_choppedStraw"].ChoppedStraw_Register.processStrawArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ);
	local realArea, area = superFunc(self, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, angle, plantValue);
	return realArea, area;
end;

function CS_DirectSeedingAddon:CS_LogInfo(message)
	if _G["FS17_choppedStraw"] ~= nil then
		_G["FS17_choppedStraw"].logInfo(5, self.version..message)
	end
end

function CS_DirectSeedingAddon:deleteMap() end;
function CS_DirectSeedingAddon:keyEvent(unicode, sym, modifier, isDown) end;
function CS_DirectSeedingAddon:mouseEvent(posX, posY, isDown, isUp, button) end;
function CS_DirectSeedingAddon:draw() end;

addModEventListener(CS_DirectSeedingAddon);
